/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Wed Apr 21 07:08:05 2010.
 *
 * -----------------------------------------------------------------------
 *
 * 
 * Copyright Ericsson AB 2010. All Rights Reserved.
 * 
 * The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved online at http://www.erlang.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_ETS (7)
#define ERTS_ALC_A_FIXED_SIZE (8)
#define ERTS_ALC_A_BINARY (9)
#define ERTS_ALC_A_DRIVER (10)

#define ERTS_ALC_A_MAX (10)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_BINARIES  (3)
#define ERTS_ALC_C_ATOM  (4)
#define ERTS_ALC_C_SYSTEM  (5)
#define ERTS_ALC_C_CODE  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (6)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (7)
#define ERTS_ALC_N_MAX_A_TEMPORARY (25)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (26)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (47)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (48)
#define ERTS_ALC_N_MAX_A_STANDARD (80)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (81)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (108)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (109)
#define ERTS_ALC_N_MAX_A_EHEAP (111)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (112)
#define ERTS_ALC_N_MAX_A_ETS (119)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (120)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (130)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (131)
#define ERTS_ALC_N_MAX_A_BINARY (132)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (133)
#define ERTS_ALC_N_MAX_A_DRIVER (141)

#define ERTS_ALC_N_MAX (141)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (209)
#define ERTS_ALC_T_NBIF_TABLE (337)
#define ERTS_ALC_T_INFO_DSBUF (465)
#define ERTS_ALC_T_ETHR_INTERNAL (593)
#define ERTS_ALC_T_HIPE (721)
#define ERTS_ALC_T_PUTENV_STR (849)
#define ERTS_ALC_T_TMP_HEAP (914)
#define ERTS_ALC_T_MSG_ROOTS (1042)
#define ERTS_ALC_T_ROOTSET (1170)
#define ERTS_ALC_T_LOADER_TMP (1378)
#define ERTS_ALC_T_NC_TMP (1490)
#define ERTS_ALC_T_TMP (1618)
#define ERTS_ALC_T_DCTRL_BUF (1746)
#define ERTS_ALC_T_TMP_DIST_BUF (1874)
#define ERTS_ALC_T_ESTACK (2002)
#define ERTS_ALC_T_PORT_CALL_BUF (2130)
#define ERTS_ALC_T_DB_TMP (2210)
#define ERTS_ALC_T_DB_MC_STK (2338)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2466)
#define ERTS_ALC_T_LOGGER_DSBUF (2642)
#define ERTS_ALC_T_TMP_DSBUF (2770)
#define ERTS_ALC_T_DDLL_TMP_BUF (2898)
#define ERTS_ALC_T_RE_TMP_BUF (3026)
#define ERTS_ALC_T_SYS_READ_BUF (3154)
#define ERTS_ALC_T_ENVIRONMENT (3282)
#define ERTS_ALC_T_PEND_SUSPEND (3347)
#define ERTS_ALC_T_PROC_LIST (3475)
#define ERTS_ALC_T_MSG_REF (3603)
#define ERTS_ALC_T_SL_BIF_TIMER (3731)
#define ERTS_ALC_T_DB_FIXATION (3875)
#define ERTS_ALC_T_DB_FIX_DEL (4003)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4131)
#define ERTS_ALC_T_DB_PROC_CLEANUP (4259)
#define ERTS_ALC_T_PORT_TASK (4435)
#define ERTS_ALC_T_PORT_TASKQ (4563)
#define ERTS_ALC_T_MISC_OP_LIST (4691)
#define ERTS_ALC_T_PORT_NAMES (4819)
#define ERTS_ALC_T_PROCS_TPROC_EL (4883)
#define ERTS_ALC_T_PROCS_CNKINF (5011)
#define ERTS_ALC_T_PROCS_PIDS (5139)
#define ERTS_ALC_T_RE_SUBJECT (5331)
#define ERTS_ALC_T_RE_STACK (5459)
#define ERTS_ALC_T_UNICODE_BUFFER (5587)
#define ERTS_ALC_T_TMP_CPU_IDS (5715)
#define ERTS_ALC_T_EXT_TERM_DATA (5779)
#define ERTS_ALC_T_FD_LIST (5971)
#define ERTS_ALC_T_POLLSET_UPDREQ (6099)
#define ERTS_ALC_T_LINK_LH (6164)
#define ERTS_ALC_T_MONITOR_LH (6292)
#define ERTS_ALC_T_NLINK_LH (6420)
#define ERTS_ALC_T_SUSPEND_MON (6548)
#define ERTS_ALC_T_LL_BIF_TIMER (6676)
#define ERTS_ALC_T_REG_TABLE (6868)
#define ERTS_ALC_T_FUN_TABLE (7012)
#define ERTS_ALC_T_DIST_TABLE (7124)
#define ERTS_ALC_T_NODE_TABLE (7252)
#define ERTS_ALC_T_MODULE_REFS (7396)
#define ERTS_ALC_T_DCACHE (7508)
#define ERTS_ALC_T_DIST_ENTRY (7636)
#define ERTS_ALC_T_NODE_ENTRY (7764)
#define ERTS_ALC_T_DRIVER (7892)
#define ERTS_ALC_T_ARG_REG (7956)
#define ERTS_ALC_T_PROC_DICT (8084)
#define ERTS_ALC_T_CALLS_BUF (8212)
#define ERTS_ALC_T_BPD (8404)
#define ERTS_ALC_T_PORT_NAME (8532)
#define ERTS_ALC_T_LINEBUF (8660)
#define ERTS_ALC_T_IOQ (8788)
#define ERTS_ALC_T_BITS_BUF (8916)
#define ERTS_ALC_T_DB_NTAB_ENT (8996)
#define ERTS_ALC_T_DDLL_PROCESS (9172)
#define ERTS_ALC_T_DDLL_HANDLE (9300)
#define ERTS_ALC_T_PORT_DATA_LOCK (9428)
#define ERTS_ALC_T_NODES_MON (9492)
#define ERTS_ALC_T_RE_HEAP (9684)
#define ERTS_ALC_T_PSD (9748)
#define ERTS_ALC_T_PRTSD (9940)
#define ERTS_ALC_T_ZLIB (10068)
#define ERTS_ALC_T_FD_ENTRY_BUF (10196)
#define ERTS_ALC_T_PRT_REP_EXIT (10324)
#define ERTS_ALC_T_ATOM_TXT (10437)
#define ERTS_ALC_T_BIF_TIMER_TABLE (10581)
#define ERTS_ALC_T_ATOM_TABLE (10693)
#define ERTS_ALC_T_EXPORT_TABLE (10853)
#define ERTS_ALC_T_MODULE_TABLE (10981)
#define ERTS_ALC_T_TAINT (11109)
#define ERTS_ALC_T_PROC_TABLE (11157)
#define ERTS_ALC_T_PORT_TABLE (11349)
#define ERTS_ALC_T_TIMER_WHEEL (11477)
#define ERTS_ALC_T_CODE (11621)
#define ERTS_ALC_T_ASYNC_Q (11733)
#define ERTS_ALC_T_DB_TABLES (11813)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (11941)
#define ERTS_ALC_T_INSTR_INFO (12117)
#define ERTS_ALC_T_SCHDLR_DATA (12181)
#define ERTS_ALC_T_RUNQS (12373)
#define ERTS_ALC_T_DDLL_ERRCODES (12501)
#define ERTS_ALC_T_PRE_ALLOC_DATA (12629)
#define ERTS_ALC_T_CPUDATA (12757)
#define ERTS_ALC_T_ARCALLBACK (12885)
#define ERTS_ALC_T_DRV_TAB (13013)
#define ERTS_ALC_T_DRV_EV_STATE (13141)
#define ERTS_ALC_T_POLLSET (13269)
#define ERTS_ALC_T_POLL_FDS (13397)
#define ERTS_ALC_T_POLL_RES_EVS (13525)
#define ERTS_ALC_T_FD_STATUS (13653)
#define ERTS_ALC_T_FD_TAB (13781)
#define ERTS_ALC_T_CS_PROG_PATH (13909)
#define ERTS_ALC_T_HEAP (13974)
#define ERTS_ALC_T_OLD_HEAP (14102)
#define ERTS_ALC_T_HEAP_FRAG (14230)
#define ERTS_ALC_T_DB_SEG (14375)
#define ERTS_ALC_T_DB_SEG_TAB (14503)
#define ERTS_ALC_T_DB_STK (14631)
#define ERTS_ALC_T_DB_TRANS_TAB (14759)
#define ERTS_ALC_T_DB_SEL_LIST (14887)
#define ERTS_ALC_T_DB_DMC_ERROR (15015)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (15143)
#define ERTS_ALC_T_DB_TERM (15271)
#define ERTS_ALC_T_PROC (15384)
#define ERTS_ALC_T_ATOM (15560)
#define ERTS_ALC_T_EXPORT (15720)
#define ERTS_ALC_T_MODULE (15848)
#define ERTS_ALC_T_REG_PROC (15896)
#define ERTS_ALC_T_MONITOR_SH (16024)
#define ERTS_ALC_T_NLINK_SH (16152)
#define ERTS_ALC_T_FUN_ENTRY (16360)
#define ERTS_ALC_T_DB_TABLE (16424)
#define ERTS_ALC_T_DRV_EV_D_STATE (16600)
#define ERTS_ALC_T_DRV_SEL_D_STATE (16728)
#define ERTS_ALC_T_DRV_BINARY (16825)
#define ERTS_ALC_T_BINARY (16953)
#define ERTS_ALC_T_DRV (17114)
#define ERTS_ALC_T_NIF (17242)
#define ERTS_ALC_T_DRV_THR_OPTS (17370)
#define ERTS_ALC_T_DRV_TID (17498)
#define ERTS_ALC_T_DRV_MTX (17626)
#define ERTS_ALC_T_DRV_CND (17754)
#define ERTS_ALC_T_DRV_RWLCK (17882)
#define ERTS_ALC_T_DRV_TSD (18010)
#define ERTS_ALC_T_ASYNC (18138)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_ETHR_INTERNAL,
  ERTS_ALC_T_HIPE,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_TMP_HEAP,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_PORT_CALL_BUF,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_RE_TMP_BUF,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_DB_PROC_CLEANUP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PORT_TASKQ,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_PROCS_TPROC_EL,
  ERTS_ALC_T_PROCS_CNKINF,
  ERTS_ALC_T_PROCS_PIDS,
  ERTS_ALC_T_RE_SUBJECT,
  ERTS_ALC_T_RE_STACK,
  ERTS_ALC_T_UNICODE_BUFFER,
  ERTS_ALC_T_TMP_CPU_IDS,
  ERTS_ALC_T_EXT_TERM_DATA,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_DRIVER,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_PORT_NAME,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DB_NTAB_ENT,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_RE_HEAP,
  ERTS_ALC_T_PSD,
  ERTS_ALC_T_PRTSD,
  ERTS_ALC_T_ZLIB,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_TAINT,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_ASYNC_Q,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_RUNQS,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PRE_ALLOC_DATA,
  ERTS_ALC_T_CPUDATA,
  ERTS_ALC_T_ARCALLBACK,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_NIF,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "info_dsbuf",
  "ethread_internal",
  "hipe_data",
  "putenv_string",
  "tmp_heap",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "port_call_buf",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "re_tmp_buf",
  "sys_read_buf",
  "environment",
  "pending_suspend",
  "proc_list",
  "msg_ref",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "db_proc_cleanup_state",
  "port_task",
  "port_task_queue",
  "misc_op_list",
  "port_names",
  "processes_term_proc_el",
  "processes_chunk_info",
  "processes_pids",
  "re_subject",
  "re_stack",
  "unicode_buffer",
  "tmp_cpu_ids",
  "external_term_data",
  "fd_list",
  "pollset_update_req",
  "link_lh",
  "monitor_lh",
  "nlink_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "driver",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "port_name",
  "line_buf",
  "io_queue",
  "bits_buf",
  "db_named_table_entry",
  "ddll_processes",
  "ddll_handle",
  "port_data_lock",
  "nodes_monitor",
  "re_heap",
  "process_specific_data",
  "port_specific_data",
  "zlib",
  "fd_entry_buf",
  "port_report_exit",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "taint_list",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "code",
  "async_queue",
  "db_tabs",
  "db_match_pseudo_proc",
  "instr_info",
  "scheduler_data",
  "run_queues",
  "ddll_errcodes",
  "pre_alloc_data",
  "cpu_data",
  "async_ready_callback",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "fd_tab",
  "cs_prog_path",
  "heap",
  "old_heap",
  "heap_frag",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "atom_entry",
  "export_entry",
  "module_entry",
  "reg_proc",
  "monitor_sh",
  "nlink_sh",
  "fun_entry",
  "db_tab",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "drv_internal",
  "nif_internal",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "async",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "binary_data",
  "atom_data",
  "system_data",
  "code_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
